class AdminController < ApplicationController
  before_filter :check_authentication, :except => [:signin]

  def index
  end

  def moderation
    @for_appruve = Url.find(:all, :conditions => ["approved = 0"])
  end

  def cat_subcat_edit
    @categories = Category.find :all
  end

  def category_add
    if request.post?
      @category = Category.new(params[:category_new])
      @category.save
      redirect_to :action => 'cat_subcat_edit'
    end
  end

  def subcategory_add
    if request.post?
      @subcategory = Subcategory.new(params[:subcat_new])
      @subcategory.save
    end
    redirect_to :action => 'cat_subcat_edit'
  end
  
  def subcategory_delete
    if request.get?
      Subcategory.delete(params[:id])
    end
    redirect_to :action => 'cat_subcat_edit'
  end
  
  def subcategory_edit
    render :partial => 'subcategory_edit'
  end

  def subcategory_edit_name
    if request.post?
      redirect_to :action => 'cat_subcat_edit'
    end
  end

  def category_delete
    if request.get?
      Category.delete(params[:id])
      Subcategory.delete(:condition => ['category_id = ?', params[:id]])
      redirect_to :action => 'cat_subcat_edit'
    end
  end

  def category_sort
    @grocery_list = Category.find(params[:id])
    @grocery_list.each do | f |
      f.position = params["grocery-list"].index(c.id.to_s)+1
      f.save
    end
  end
  
  def check_authentication
    unless session[:user]
      session[:intended_action]     = action_name
      session[:intended_controller] = controller_name
      redirect_to :action => "signin"
    end
  end

  def signin
    if request.post?
      session[:user] = User.authenticate(params[:user][:login], params[:user][:password])#.id
      redirect_to :action => session[:intended_action], :controller => session[:intended_controller]
    end
   end

  def logout
    session[:user] = nil
    redirect_to :action => "signin"
  end
end
